Merge branch 'master' of ssh://opencfd@repo.or.cz/srv/git/OpenFOAM-1.6.x
[OpenFOAM-1.6.x.git] / bin / foamEtcFile
blobe3faab4121d1108195689c0d548240302a5510b4
1 #!/bin/sh
2 #------------------------------------------------------------------------------
3 # ========= |
4 # \\ / F ield | OpenFOAM: The Open Source CFD Toolbox
5 # \\ / O peration |
6 # \\ / A nd | Copyright (C) 1991-2009 OpenCFD Ltd.
7 # \\/ M anipulation |
8 #-------------------------------------------------------------------------------
9 # License
10 # This file is part of OpenFOAM.
12 # OpenFOAM is free software; you can redistribute it and/or modify it
13 # under the terms of the GNU General Public License as published by the
14 # Free Software Foundation; either version 2 of the License, or (at your
15 # option) any later version.
17 # OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
18 # ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
19 # FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
20 # for more details.
22 # You should have received a copy of the GNU General Public License
23 # along with OpenFOAM; if not, write to the Free Software Foundation,
24 # Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
26 # Script
27 # foamEtcFile
29 # Description
30 # Locate user/site/shipped file with the semantics used in the
31 # ~OpenFOAM/fileName expansion
33 #-------------------------------------------------------------------------------
34 unset listOpt quietOpt
36 usage() {
37 [ "$quietOpt" = true ] && exit 1
39 exec 1>&2
40 while [ "$#" -ge 1 ]; do echo "$1"; shift; done
41 cat<<USAGE
43 usage: ${0##*/} [OPTION] fileName
44 ${0##*/} -list
46 options:
47 -l | -list list the directories to be searched
48 -q | -quiet suppress all normal output
50 Locate user/site/shipped file with the semantics used in the
51 ~OpenFOAM/fileName expansion
53 Exit status 0 when the file is found and output resolved path to stdout.
54 Exit status 1 for miscellaneous errors.
55 Exit status 2 when the file is not found.
57 USAGE
58 exit 1
62 # parse options
63 while [ "$#" -gt 0 ]
65 case "$1" in
66 -h | -help)
67 usage
69 -l | -list)
70 listOpt=true
71 shift
73 -q | -quiet)
74 quietOpt=true
75 shift
77 -*)
78 usage "unknown option: '$*'"
81 break
83 esac
84 done
87 # Save the essential bits of information:
88 nArgs=$#
89 fileName="$1"
91 # The various places to be searched:
92 set -- \
93 $HOME/.${WM_PROJECT:-OpenFOAM}/$WM_PROJECT_VERSION \
94 $HOME/.${WM_PROJECT:-OpenFOAM} \
95 $WM_PROJECT_INST_DIR/site/$WM_PROJECT_VERSION \
96 $WM_PROJECT_INST_DIR/site \
97 $WM_PROJECT_DIR/etc
101 # The main routine
104 if [ "$listOpt" = true ]
105 then
107 # list directories, or potential file locations
108 [ "$nArgs" -le 1 ] || usage
110 # a silly combination, but -quiet has precedence
111 [ "$quietOpt" = true ] && exit 0
113 for dir
115 if [ "$nArgs" -eq 1 ]
116 then
117 echo "$dir/$fileName"
118 else
119 echo "$dir"
121 done
122 exit 0
124 else
126 [ "$nArgs" -eq 1 ] || usage
128 for dir
130 if [ -f "$dir/$fileName" ]
131 then
132 [ "$quietOpt" = true ] || echo "$dir/$fileName"
133 exit 0
135 done
140 # general error, eg file not found
141 exit 2
143 #------------------------------------------------------------------------------